/*! Built with http://stenciljs.com */
import { h } from './bscomponents.core.js';
import { p as _size, q as customEvent, r as removeClass, s as hasClass } from './chunk-d2b1926f.js';
import { a as closest } from './chunk-217bc533.js';
import { a as getTransitionDurationFromElement } from './chunk-df46c743.js';
import './chunk-e18b632f.js';
var BsAlert = /** @class */ (function () {
    function BsAlert() {
        this.closeEventName = 'close.bs.alert';
        this.closedEventName = 'closed.bs.alert';
    }
    BsAlert.prototype.handleFocusOut = function (event) {
        var closestDismissEl = closest(event.target, '[data-dismiss="alert"]');
        if (closestDismissEl && this.alertEl.contains(closestDismissEl)) {
            if (event.stopPropagation) {
                event.stopPropagation();
                event.preventDefault();
            }
            this.close();
        }
    };
    BsAlert.prototype.destroyAlert = function () {
        this.alertEl.parentNode.removeChild(this.alertEl);
        customEvent(this.alertEl, this.closedEventName);
    };
    BsAlert.prototype.close = function () {
        var _this = this;
        var closeEvent = customEvent(this.alertEl, this.closeEventName);
        if (closeEvent.defaultPrevented) {
            return;
        }
        removeClass(this.alertEl, 'show');
        if (!hasClass(this.alertEl, 'fade')) {
            this.destroyAlert();
            return;
        }
        var transitionDuration = getTransitionDurationFromElement(this.alertEl);
        setTimeout(function () {
            _this.destroyAlert();
        }, transitionDuration);
    };
    BsAlert.prototype.alert = function (alertOptions) {
        if (_size(alertOptions) === 0) {
            return this.alertEl;
        }
        if (alertOptions === 'close') {
            this.close();
            return true;
        }
        if (typeof alertOptions === 'string') {
            throw new Error("No method named \"" + alertOptions + "\"");
        }
        return null;
    };
    BsAlert.prototype.render = function () {
        return (h("slot", null));
    };
    Object.defineProperty(BsAlert, "is", {
        get: function () { return "bs-alert"; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BsAlert, "properties", {
        get: function () {
            return {
                "alert": {
                    "method": true
                },
                "alertEl": {
                    "elementRef": true
                },
                "close": {
                    "method": true
                },
                "closedEventName": {
                    "type": String,
                    "attr": "closed-event-name"
                },
                "closeEventName": {
                    "type": String,
                    "attr": "close-event-name"
                }
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BsAlert, "listeners", {
        get: function () {
            return [{
                    "name": "click",
                    "method": "handleFocusOut"
                }];
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BsAlert, "style", {
        get: function () { return "bs-alert {\n  display: block;\n}"; },
        enumerable: true,
        configurable: true
    });
    return BsAlert;
}());
export { BsAlert };
